function startupEditor(){
    Splitty.setup();
    ace.require("ace/ext/language_tools");
    window.editor = ace.edit("editor");
    window.editor.setTheme("ace/theme/monokai");
    window.editor.getSession().setMode("ace/mode/text");
    window.editor.setOptions({
        enableBasicAutocompletion: true,
        enableSnippets: true,
        enableLiveAutocompletion: false,
        showPrintMargin:false
    });
    window.socket = io();
    document.addEventListener("DOMContentLoaded", function(event) { 
        window.socket.emit("config");
        window.socket.on("config",function(crypt_config){
            var config = Splitty.decrypt(crypt_config);            
            Splitty.setConfig(config);
            Splitty.startup();
            Toolbar.render();
            loadBaseModules();
            
        });           
    });
    Splitty.setSocket(window.socket);
    Splitty.setEditor(window.editor);
    FileUtils.setup(window.editor,window.socket);        
    Shell.setup(window.editor,window.socket);
    Shortcut.setup(window.editor);
    window.editor.$blockScrolling = Infinity;

    document.getElementById("optionValue").addEventListener("keyup",function(event) {
        if(event.keyCode === 13) EditorUI.onEnterOption(document.getElementById("optionValue").value);
        else if(event.keyCode === 27) EditorUI.onEscape(document.getElementById("optionValue").value);
        else EditorUI.onkeyup(document.getElementById("optionValue").value);
    });

    document.getElementById("optionValue").addEventListener("change",function(event) {
        EditorUI.onChange(document.getElementById("optionValue").value);
    });


    window.editor.on("focus", function() { 
        setTimeout(EditorUI.closeInputBox,100);
    });
    
    if (window.top.document.getElementById('rightSideFrame').getAttribute('src') === "") {
        window.editor.focus();
    }
}


function loadBaseModules(){
  Loader.load("modal");
  Loader.load("filetree").then(function(){
      FileTree.open(function(){
          Loader.loadJS("filetreeactions").then(function(){
              var actions = FileTreeActions.getActions();
              actions.each(function(a){
                  FileTree.addAction(a);
              });
          });
      });        
  });

    
}

startupEditor();