Module.new("FileTree",function(){
    /*
    Register all events that filetree can fire
    */
    const SL_NODE = "FILE_TREE_SELECTED_NODE";
    Events.register(SL_NODE);

    var self = {};
    var actions = [];
    self.addAction = function(action){
        actions.push(action);
    }
    
    function buildContext(){
        self.ctx = {};
        self.ctx.workspace = Splitty.config().workspace + Splitty.config().sep;        
        self.ctx.folderName = "explorer";
    };
    
    self.open = function(doneCallback)  {
        buildContext();
        SideView.render("filetree",self.ctx);    
        function customMenu(node) {
                var items = {};
                var filtred = actions;
                filtred = actions.where(function(a) { return a.isAvailable(node)});                
                filtred.each(function(action){
                    items[action.id] = action;                    
                });    
                items.ccp = false;
                return items;
        }
            
        $('#jstree').jstree({
                "plugins" : [ "contextmenu" ],
                'contextmenu' : {
                    'items' : customMenu
                },
                'core' : {
                "check_callback" : true,  
                'data' : {
                    'cache':false,
                    'url' : function (node) {
                    return '/_splitty/path';
                    },
                    'data' : function (node) {
                    return { 'id' : node.id};
                    }
                }
        }});
        
        $('#jstree').on("select_node.jstree",function(event,treeNode){
          Events.fire(SL_NODE,treeNode.node)
        });
        if(typeof(doneCallback) ==="function"){
            setTimeout(function(){
                $('#jstree').jstree(true).open_node(self.ctx.workspace);
            },500);
            doneCallback();
        }
    };
    return self;

});






