Module.new("FileTreeActions",function(){
    var self = {};
    var tree = $("#jstree").jstree(true);
    var actions = [];
    self.getActions = function(){
      // Splitty.onUnix(function(){
            actions.push(self.getNewFileAction());
            actions.push(self.getNewFolderAction());
            actions.push(self.getRenameFileAction());
            actions.push(self.getDeleteFileAction());
            actions.push(self.getCopyFileAction());
            actions.push(self.getPasteFileAction());
            actions.push(self.getCutFileAction());
            //TODO
            //actions.push(self.getUploadFileAction());
       //}); 
       
       return actions;
    };
    self.getCopyFileAction = function(){
        var action = {};
        action.id = "copyFile";
        action.label = "Copy";
        action.action = function (data) {
            var $node = tree.get_node(data.reference);
            var name = getPathFromNode($node);            
            var pipe = {};
            pipe.from = name;
            pipe.action = "copy";
            Splitty.setOnSession("$copyAndPastePipe",pipe);
        };
        action.icon = null;       
        action.isAvailable = function(node){
            return true;
        };
        return action;
    };
    
    self.getPasteFileAction = function(){
        var action = {};
        action.id = "pasteFile";
        action.label = "Paste";
        action.action = function (data) {
            var $node = tree.get_node(data.reference);
            var name = getPathFromNode($node);            
            var pipe = Splitty.getOnSession("$copyAndPastePipe");            
            if (pipe) {
                pipe.to = name;
                if (pipe.action === "copy") {
                    Shell.send("cpRec",pipe,self.refreshTree);
                }else {
                    console.log(pipe);
                    console.log(name);
                    FileAction.mv(pipe.from,pipe.to,self.refreshTree);
                }
                Splitty.deleteOnSession("$copyAndPastePipe");
            }
        };
        action.icon = null;
        action.isAvailable = function(node){
           var pipe = Splitty.getOnSession("$copyAndPastePipe");            
           return typeof(pipe) !== "undefined";           
        };
        return action;
    };
    
    self.getCutFileAction = function(){
        var action = {};
        action.id = "cutFile";
        action.label = "Cut";
        action.action = function (data) {            
            var $node = tree.get_node(data.reference);
            var name = getPathFromNode($node);            
            var pipe = {};
            pipe.from = name;
            pipe.action = "cut";
            Splitty.setOnSession("$copyAndPastePipe",pipe);
        };
        action.icon = null;
        action.isAvailable = function(node){
            return true;
        };
        return action;
    };

    self.getUploadFileAction = function(){
        var action = {};
        action.id = "uploadFile";
        action.label = "Upload File";
        action.action = function (data) {            
            alert("TODO");
        };
        action.icon = null;
        action.applyOnDirectory = true;
        action.applyOnFile = false;
        action.isAvailable = function(node){
            if (node.id.endsWith("/") || node.id.endsWith("\\")) {
                return true;
            }
            return false;
        };
        return action;
    };
  
    self.getNewFileAction = function(){
        var action = {};
        action.id = "newFile";
        action.label = "New File";
        action.action = function (data) {            
            var $node = tree.get_node(data.reference);
            var path = getPathFromNode($node);
            var node = {};
                node.icon = "ion-android-document";
                node.text = "untitled";
            if (!$node.state.opened){
              tree.open_node($node,function(a){
                var $$node = tree.create_node($node, node, 'last');
                $('#jstree').on('rename_node.jstree',onRename.bind({"method":"createFile"})).jstree(true);
                tree.edit($$node);
              });
              
            }else{
              var $$node = tree.create_node($node, node, 'last');
                $('#jstree').on('rename_node.jstree',onRename.bind({"method":"createFile"})).jstree(true);
                tree.edit($$node);
            }
        };
        action.icon = null;
        action.isAvailable = function(node){
            if (node.id.endsWith("/") || node.id.endsWith("\\")) {
                return true;
            }
            return false;
        };
        return action;
    };
    function onRename (e,node) {
      var basePath = node.node.parent;
      if (basePath === Splitty.config().workspace){
        basePath = Splitty.config().workspace + "/";
      }
      var fileName = basePath + node.text;
      var oldName = basePath + node.old;
      var create = null;
      if (this.method === "createFile"){
        create = FileAction.createFile;
      } else if (this.method === "createFolder") {
        create = FileAction.mkdir;
      } else if (this.method === "rename") {
        FileUtils.close();
        FileAction.renameFile(fileName,oldName,function(){
          tree.refresh();
        });
      }
      typeof(create) === "function" && create(fileName,function() {tree.refresh() });
      $('#jstree').off('rename_node.jstree')
    }
    
    
    self.getNewFolderAction = function(){
        
        var action = {};
        action.id = "newFolder";
        action.label = "New Folder";
        action.action = function (data) {            
            var $node = tree.get_node(data.reference);
            var path = getPathFromNode($node);
            var node = {};
                node.icon = "ion-android-folder";
                node.text = "untitled";
            if (!$node.state.opened){
              tree.open_node($node,function(a){
                var $$node = tree.create_node($node, node, 'last');
                $('#jstree').on('rename_node.jstree',onRename.bind({"method":"createFolder"})).jstree(true);
                tree.edit($$node);
              });
              
            }else{
              var $$node = tree.create_node($node, node, 'last');
                $('#jstree').on('rename_node.jstree',onRename.bind({"method":"createFolder"})).jstree(true);
                tree.edit($$node);
            }
        };
        action.icon = null;
        action.isAvailable = function(node){
            if (node.id.endsWith("/") || node.id.endsWith("\\")) {
                return true;
            }
            return false;
        };
        return action;
    };
    
    
    self.getRenameFileAction = function(){
        var action = {};
        action.id = "renameFile";
        action.label = "Rename";
        action.action = function (data) {
          var $node = tree.get_node(data.reference);
          var path = getPathFromNode($node);
          $('#jstree').on('rename_node.jstree',onRename.bind({"method":"rename"})).jstree(true);
          tree.edit($node);
        };
        action.icon = null;
        action.isAvailable = function(node){
            return true;
        };
        return action;
    };

    self.getDeleteFileAction = function(){
        var action = {};
        action.id = "deleteFile";
        action.label = "Delete";
        action.action = function (data) {
          var $node = tree.get_node(data.reference);
          var path = getPathFromNode($node);
          Modal.show({
                title:"Delete",
                body:'Are you sure to delete <b>' + $node.text + '</b> ?',
                icons:[{icon:"ion-android-delete",label:"delete"},
                        {icon:"ion-close-circled",style:"color:red;",label:"cancel"}],
                callback:function(buttonID){
                    var fileName = path;
                    try{
                        switch (buttonID) {
                            case 0:
                                if(isDirectory($node.id)){
                                    FileAction.deleteRecursive(fileName,self.refreshTree);
                                }else{
                                    FileAction.delete(fileName,self.refreshTree);
                                    FileUtils.close();
                                }
                                break;
                            default:
                                // code
                        }
                    }catch(e){
                        console.log(e);
                        return -1;
                    }
                }
            });
        };
        action.icon = null;
        action.isAvailable = function(node){
            return true;
        };
        return action;
    }
    
    function isDirectory(path){
      return path.endsWith("/");
    }
    function getPathFromNode(node){
       if (node.id.endsWith('*') || node.id.endsWith('@')) {
         return node.id.substring(0, node.id.length -1);    
       } 
       return node.id.substring(0, node.id.length);
    };
    
    self.openFile = function(node)  {
      if(isDirectory(node.id)) return;
      var fullPath = getPathFromNode(node);
      FileUtils.open(fullPath);
    }
    self.refreshTree = function() {
      tree.refresh();
      setTimeout(function(){
        $('#jstree').jstree(true).open_node(Splitty.config().workspace+Splitty.config().sep);
      },700);
    }
    
    self.createFile = function()  {
       createItem("createFile","ion-android-document");
    };
    
    self.createFolder = function()  {
       createItem("createFolder","ion-android-folder");
    };
    
    self.uploadFile = function()  {
      alert("TODO");
    };
    
    function createItem(method, icon){
      var node = {};
       node.icon = icon;
       node.text = "untitled";
       var $$node = tree.create_node('#', node, 'last');
       $('#jstree').on('rename_node.jstree',onRename.bind({"method":method})).jstree(true);
       tree.edit($$node);
    }
    Events.when("FILE_TREE_SELECTED_NODE",self.openFile);
    
    return self;
});