var Module = (function(){
    var self = {};
    self.new = function(moduleName,moduleCode) {
        window[moduleName] = moduleCode();
        Loader.loadFinished(moduleName);
    };
    return self;
})();


var Loader = (function(){
    var self = {};
    var cache = {};
    var currentLoadModule = "";
    var initCallbacks = {};
    
    self.loadJS = function(partialName)  {
      if (typeof(cache[partialName]) !== "undefined") return self;
        cache[partialName] = true;
        currentLoadModule = partialName;
        var fileref=document.createElement('script');
        fileref.setAttribute("type","text/javascript");
        fileref.async = true;
        fileref.setAttribute("src", "modules/" + partialName + "/" + partialName + ".js");
       if (typeof fileref!="undefined")
          document.getElementsByTagName("head")[0].appendChild(fileref);
      return self;
    }
    
    self.load = function(partialName)  {
        if (typeof(cache[partialName]) !== "undefined") return self;
        
        currentLoadModule = partialName;  
       var  fileref=document.createElement("link");
            fileref.setAttribute("rel", "stylesheet");
            fileref.setAttribute("type", "text/css");
            fileref.setAttribute("href","modules/"+ partialName + "/" + partialName + ".css");
         if (typeof fileref!="undefined")
                document.getElementsByTagName("head")[0].appendChild(fileref);
                
         var xhttp = new XMLHttpRequest();
         xhttp.open("GET", "modules/"+ partialName + "/" + partialName + ".tmpl", true);
         xhttp.send();
         xhttp.onreadystatechange = function() {
              if (xhttp.readyState == 4 && xhttp.status == 200) {
                  var template=document.createElement('script');
                  template.setAttribute("type","text/handlebars");
                  template.setAttribute("id",partialName);
                  template.innerHTML = xhttp.responseText;
                  document.getElementsByTagName("body")[0].appendChild(template);
                  fileref=document.createElement('script');
                  fileref.setAttribute("type","text/javascript");
                  fileref.async = true;
                  fileref.setAttribute("src", "modules/" + partialName + "/" + partialName + ".js");
                  if (typeof fileref!="undefined")
                      document.getElementsByTagName("head")[0].appendChild(fileref);
              }
         };
         return self;
    };
    self.then = function(callback)  {
        if(!initCallbacks[currentLoadModule]) initCallbacks[currentLoadModule] = [];
        initCallbacks[currentLoadModule].push(callback);
    };
    self.loadFinished = function(moduleName)  {
        var lowerCase = moduleName.toLowerCase();
        if(initCallbacks[lowerCase]){
            initCallbacks[lowerCase].each(function(callback) { callback() });
        }
    };
    self.exec = function(entrypoint)  {
        var partialName = entrypoint.split(".")[0].toLowerCase();
        if(typeof(cache[partialName]) === "undefined") {
            var interval = setInterval(function(){
               if(typeof(cache[partialName]) !== "undefined"){
                   clearInterval(interval);
                   eval(entrypoint);
               }
            },150);
        }else{
            eval(entrypoint);    
        }
    };
    
    return self;
})();