var Shell = (function(){
    var self = {}
    var _editor = null
    var _socket = null
    var stdioBuffer =  []
    var stderrBuffer =  []
    var stdioCallback = null
    self.setEditor = function(editor) { _editor = editor }
    
    self.setSocket = function(socket) { _socket = socket }
    
    self.ls = function() { exec("ls") }

    self.exec = function(command,callback) { exec(command,callback) }
    
    self.outputCallback = function(data){
        stdioBuffer.push(data)
        if (typeof(stdioCallback) === "function")
            stdioCallback(data)
        
    }
    
    self.bind = function() {
        socket.on("stdout", function(data)  {
            var resp = Splitty.decrypt(data);
            self.outputCallback(resp.stdout);
        });
        socket.on("stderr", function(data)  {
            var resp = Splitty.decrypt(data);
            self.outputCallback(resp.stderr);
        });
    };
    
    self.clear = function() { stdioBuffer = [] };
    
    self.clearStdErr = function() { stderrBuffer = [] };

    self.stdio = function() { return stdioBuffer.join("\n") };

    self.setup = function(editor,socket) {
        self.setEditor(editor);
        self.setSocket(socket);
        self.bind();
    };
    
    self.find = function(value,callback)  {
        socket.emit("find", Splitty.encrypt({text:value}));
        socket.on("find",function(data){
            var resp = Splitty.decrypt(data);
            callback(resp.founded);
        });
    };
    
    function exec(cmd,callback){ 
        stdioBuffer = [];
        stdioCallback = callback;
        socket.emit("command",  Splitty.encrypt({command:cmd})); 
    }
    
    self.send = function(channel,data,callback){
        _socket.emit(channel,Splitty.encrypt(data));
        _socket.on(channel,function(data){
            var plain = Splitty.decrypt(data);
            typeof(callback) === "function" && callback(plain);
        });
    };
    return self;
})();