var EditorUI = (function(){
    var self = {}    
    var currentActionContext = null
    
    _ = function(id) { return document.getElementById(id) };
    
    
    
    self.openBox = function()  {
        _("header").style.height = "50px";
        _('ctxout').style.display = "none";
        _("optionValue").focus();
    };
    
    self.actionBoxValue = function() { return _("optionValue").value };
    self.block = function() { document.getElementById("optionValue").disabled = true };
    self.unblock = function()  {
        document.getElementById("optionValue").disabled = false;
        document.getElementById("optionValue").focus();
    };
    self.setActionText = function(value)  {
        _("optionValue").value = value; 
        _("optionValue").focus();
    };
    self.getActionText = function() { return _("optionValue").value };
    
    
    self.onEnterOption = function(value)  {       
        var ret = currentActionContext.execute(value);
        if(ret < 0 || typeof(ret) === "undefined")
            self.closeInputBox();
    };
    
    self.onChange = function(value) {
        if(typeof(currentActionContext["onchange"]) !== "undefined") {
            var ret = currentActionContext.onchange(value);
            if(ret < 0 || typeof(ret) === "undefined")
                self.closeInputBox();   
        }
    }
    
    self.onkeyup = function(value)  { 
        if(typeof(currentActionContext["onkeyup"]) !== "undefined")
            currentActionContext.onkeyup(value);
    }
    
    self.onEscape = function()  {
        self.closeInputBox();
    };
    
    self.openFile = function()  {
        self.openBox();
        _("optionValue").value = "";
        _("optionValue").focus();
    };
    
    self.closeInputBox = function() {
        _('header').style.height = '0px';
        var list = _('ctxout');
        list.innerHTML = "";
        list.style.display = "none";
        _("optionValue").value = "";
        editor.focus();
    };

    self.setupContext = function(context)  {
      currentActionContext = context;
      if(typeof(currentActionContext["init"]) !== "undefined"){
          self.openBox();
          self.setLabelAction(context.getLabelAction());
          currentActionContext.init(_("optionValue"));
      }else if(typeof(currentActionContext["action"]) !== "undefined"){
          currentActionContext.action();
      }
    };

    self.setLabelAction = function(value) {
        _("spanDescription").innerHTML = "&nbsp;" + value + " >";
    };
    
    self.renderOutputAction = function(data,template) {
        if( _('header').style.height == "0px") {
            document.getElementById('ctxout').style.display = "none";    
            return;
        }
        document.getElementById('ctxout').style.display = "block";
        Template.render(data,template,"ctxout");
    };
    
    return self
})();


//Controller for rendering modules on sideview
var SideView = (function(){
    var self = {};
    self.render = function(moduleName, handlebarsContext){
        Template.render(handlebarsContext,moduleName,"sidecontent");
    };
    self.close = function(){
        var sidebar = document.getElementById('sidebarContainer');
        sidebar.style.minWidth = "0px";
        sidebar.style.maxWidth = "0px";
    };
    self.open = function(){
        var sidebar = document.getElementById('sidebarContainer');
        sidebar.style.minWidth = "240px";
        sidebar.style.maxWidth = "240px";
    };
    self.isOpen = function(){
        var sidebar = document.getElementById('sidebarContainer');
        return sidebar.style.maxWidth === "240px";
    };

    self.toggle = function(){
        if (!self.isOpen()) {
            self.open();
        } else {
            self.close();
        }        
    };


    return self;
})();