var path     = require('path');
var crypt    = require('../security/crypt');
var userArgs = process.argv.slice(2);

module.exports = (function(){
    /**Splitty configurations */
    function isDef(obj){
        return typeof(obj) !== "undefined";
    }
    var config = {};
    
    try{
        config = JSON.parse(fs.readFileSync(path.join(process.cwd(),"/.splitty.json"), "utf-8"));
    }catch(e){
        config = {};
    }
    var aes_key = crypt.guid();
    config["host_path"] = pwd().toString('utf-8');
    config["platform"]  = process.platform;
    config["workspace"] = process.cwd();
    config["workspace_name"] = path.basename(process.cwd());
    config["sep"] = path.sep;
    if(!isDef(config["port"])) config["port"] = "8000";
    if(!isDef(config["bindAddress"])) config["bindAddress"] = "localhost";
    if(!isDef(config["key"])) config["key"] = aes_key;
    else aes_key = config["key"];

    if(!config["files"]) config["files"] = {};

    userArgs.forEach((param)=>{
    if(param.indexOf("=") > 0){    
        var map = param.split("=");
        if(map[0] === "key"){
            aes_key = map[1];
            map[1] = aes_key;
        }
        config[map[0]] = map[1];
    }else{
        if(!config["files"]["toOpen"]) config["files"]["toOpen"] = [];
        config["files"]["toOpen"].push(param);
    }
    });
    return config;
}());