var crypt = require('../security/crypt');
module.exports = (function(){
    var self = {};
    self.actions = {};
    self.register = function(controller){
        for(var prop in controller){
            if(controller.hasOwnProperty(prop)){
                self.actions[prop] = function(data){                     
                     if(data){
                         data = crypt.decrypt(data);
                     }
                     var parentContext = this;                    
                     var send = function(channel,output){
                         parentContext.socket.emit(channel,crypt.encrypt(output));
                     };
                     controller[this.method].bind({"send":send})(data);
                }
            }
        }
    };
    /** All the backend controllers needs to be declared here */
    self.prepare = function(){
        self.register(require('../conf/controller'));
        self.register(require('../shell/controller'));
        self.register(require('../files/controller'));        
    };

    self.getControllers = function(){
        var list = [];
        for(var prop in self.actions){
            if(self.actions.hasOwnProperty(prop)){
                var obj = {};
                obj.method = prop;
                obj.func = self.actions[prop];
                list.push(obj);
            }
        }
        return list;
    }

    return self;
})();